#include <iostream>
#include <vector>

long long mod = 1e9;

using namespace std;

long long maximum(vector<long long> &a, long long l, long long r) {
    if (r == l) {
        return a[l];
    }
    long long m = (r + l) / 2;
    long long x = maximum(a, l, m);
    long long y = maximum(a, m + 1, r);
    return max(x, y);
}

int main() {
    long long n, f;
    cin >> n >> f;
    if (f == 1) {
        vector<long long> d(n);
        for (long long i = 0; i < n; i++) {
            cin >> d[i];
        }
        vector<long long> a(n);
        for (long long j = 0; j < n; j++) {
            a[j] = d[j] - j;
        }
        long long ans = maximum(a, 0, n - 1), ansi = 0;
        for (long long i = 1; i < n; i++) {
            a[i - 1] -= n;
            long long mx = maximum(a, 0, n - 1) + i;
            if (ans > mx) {
                ans = mx;
                ansi = i;
            }
        }
        cout << ans << ' ' << ansi + 1;
    } else {
        long long m, x, y, z;
        cin >> m >> x >> y >> z;
        vector<long long> c(m);
        for (long long i = 0; i < m; i++) {
            cin >> c[i];
        }
        vector<long long> d(n);
        for (long long i = 0; i < m; i++) {
            d[i] = c[i];
        }
        for (long long i = m; i < n; i++) {
            d[i] = (x * d[i - 2] + y * d[i - 1] + z) % mod + 1;
        }
        vector<long long> a(n);
        for (long long i = 0; i < n; i++) {
            a[i] = d[i] - i;
        }
        long long ans = 0;
        for (long long i = 0; i < n; i++) {
            if (ans < a[i]) {
                ans = a[i];
            }
        }
        cout << ans << ' ' << 1;
    }

    return 0;
}
