#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool cmp(pair<long long, long long> a, pair<long long, long long> b) {
    return a.first * b.second < a.second * b.first;
}

bool cmp1(long long a, long long b) {
    return a > b;
}

long long nod(long long a, long long b) {
    if (b == 0) {
        return a;
    }
    return nod(b, a % b);
}

int main() {
    long long n, q;
    cin >> n >> q;
    vector<long long> a(n), b(n);
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (long long i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<pair<long long, long long>> v;
    if (n <= 500) {
        for (long long i = 0; i < n; i++) {
            for (long long j = 0; j < n; j++) {
                v.emplace_back(a[i], b[j]);
            }
        }
    } else {
        sort(a.begin(), a.end());
        sort(a.begin(), a.end(), cmp1);
        for (long long i = 0; i < 100; i++) {
            for (long long j = 0; j < 100; j++) {
                v.emplace_back(a[i], b[j]);
            }
        }
    }

    sort(v.begin(), v.end(), cmp);
    while (q--) {
        long long c;
        cin >> c;
        long long x = v[c - 1].first, y = v[c - 1].second;
        long long nd = nod(x, y);
        cout << x / nd << ' ' << y / nd << '\n';
    }

    return 0;
}