#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
vector<vector<pair<long long, long long>>> gr;
vector<long long> dp1, dp2;

long long n, k;

void dfs(long long v, long long p) {
    long long t = 0;
    dp1[v] = 0;
    for (auto to: gr[v]) {
        if (to.first != p) {
            dfs(to.first, v);
            if (dp1[to.first] == dp2[to.first]) {
                t++;
            }
            dp1[v] += dp1[to.first];
        }
    }
    if (t >= k) {
        dp2[v] = dp1[v] + k - 1;
        dp1[v] += k;
    } else {
        dp1[v] += t;
        dp2[v] = dp1[v];
    }
}

int main() {
    cin >> n >> k;
    gr.resize(n);
    for (long long i = 1; i < n; i++) {
        long long p, w;
        cin >> p >> w;
        p--;
        gr[i].emplace_back(p, w);
        gr[p].emplace_back(i, w);
    }
    dp1.resize(n);
    dp2.resize(n);
    dfs(0, -1);
    cout << dp1[0] << ' ' << 0;

    return 0;
}
