#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
vector<vector<pair<long long, long long>>> gr;
vector<long long> dp1, dp2, dp1w, dp2w;

long long n, k;

void dfs(long long v, long long p) {
    vector<pair<long long, long long>> t, t2;

    dp1[v] = 0;
    dp1w[v] = 0;
    for (auto to: gr[v]) {
        if (to.first != p) {
            dfs(to.first, v);
            if (dp1[to.first] == dp2[to.first]) {
                t.emplace_back(to.first, to.second);
            } else {
                t2.emplace_back(to.first, to.second);
            }
            dp1[v] += dp1[to.first];
            dp1w[v] += dp1w[to.first];
        }
    }
    if (t.size() >= k) {
        dp2[v] = dp1[v] + k - 1;
        dp1[v] += k;
        set<long long> w;
        for (auto i: t) {
            w.insert(dp1w[i.first] - dp2w[i.first] - i.second);
        }
        dp2w[v] = dp1w[v];
        for (long long i = 0; i < k - 1; i++) {
            dp2w[v] -= *w.begin();
            w.erase(w.begin());
        }
        dp1w[v] = dp2w[v];
        dp1w[v] -= *w.begin();
    } else {
        dp1[v] += t.size();
        dp2[v] = dp1[v];
        dp2w[v] = dp1w[v];
        for (auto i: t) {
            dp2w[v] += dp2w[i.first] + i.second - dp1w[i.first];
        }

        set<long long> w;
        for (auto i: t) {
            w.insert(dp1w[i.first] - dp2w[i.first] - i.second);
        }
        for (long long i = 0; i < k - t.size() - 1; i++) {
            long long x = *w.begin();
            if (x > 0 || w.empty()) {
                break;
            }
            dp2w[v] -= *w.begin();
            w.erase(w.begin());
        }
        dp1w[v] = dp2w[v];
        dp1w[v] -= *w.begin();
    }
}

int main() {
    cin >> n >> k;
    gr.resize(n);
    for (long long i = 1; i < n; i++) {
        long long p, w;
        cin >> p >> w;
        p--;
        gr[i].emplace_back(p, w);
        gr[p].emplace_back(i, w);
    }
    dp1.resize(n);
    dp2.resize(n);
    dp1w.resize(n);
    dp2w.resize(n);
    dfs(0, -1);
    cout << dp1[0] << ' ' << dp1w[0];

    return 0;
}
