#include <iostream>
#include <vector>

int mod = 1e9;

using namespace std;

int maximum(vector<int> &a, int l, int r) {
    if (r == l) {
        return a[l];
    }
    int m = (r + l) / 2;
    int x = maximum(a, l, m);
    int y = maximum(a, m + 1, r);
    return max(x, y);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, f;
    cin >> n >> f;
    if (f == 1) {
        vector<int> d(n);
        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }
        vector<int> a(n);
        for (int j = 0; j < n; j++) {
            a[j] = d[j] - j;
        }
        int ans = maximum(a, 0, n - 1), ansi = 0;
        for (int i = 1; i < n; i++) {
            a[i - 1] -= n;
            int mx = maximum(a, 0, n - 1) + i;
            if (ans > mx) {
                ans = mx;
                ansi = i;
            }
        }
        cout << ans << ' ' << ansi + 1;
    } else {
        int m, x, y, z;
        cin >> m >> x >> y >> z;
        vector<int> c(m);
        for (int i = 0; i < m; i++) {
            cin >> c[i];
        }
        vector<int> d(n);
        for (int i = 0; i < m; i++) {
            d[i] = c[i];
        }
        for (int i = m; i < n; i++) {
            d[i] = (x * d[i - 2] + y * d[i - 1] + z) % mod + 1;
        }
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = d[i] - i;
        }
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (ans < a[i]) {
                ans = a[i];
            }
        }
        cout << ans << ' ' << 1;
    }

    return 0;
}
