#include <iostream>
#include <vector>

using namespace std;

struct triangle {
    long long x1, y1, x2, y2, x3, y3;
};

long long len(long long x1, long long y1, long long x2, long long y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

bool equals(triangle x, triangle y) {
    vector<long long> a1, b1;
    a1.push_back(len(x.x1, x.y1, x.x2, x.y2));
    a1.push_back(len(x.x2, x.y2, x.x3, x.y3));
    a1.push_back(len(x.x3, x.y3, x.x1, x.y1));
    b1.push_back(len(y.x1, y.y1, y.x2, y.y2));
    b1.push_back(len(y.x2, y.y2, y.x3, y.y3));
    b1.push_back(len(y.x3, y.y3, y.x1, y.y1));
    if (a1[0] == b1[0]) {
        return a1[1] == b1[1] && a1[2] == b1[2];
    } else if (a1[0] == b1[1]) {
        return a1[1] == b1[2] && a1[2] == b1[0];
    } else if (a1[0] == b1[2]) {
        return a1[1] == b1[0] && a1[2] == b1[1];
    }
    return false;
}

vector<long long> b;
long long n, t;
long long s = 0;
vector<vector<long long>> ans;
vector<triangle> a;

void foo(long long ind) {
    if (ind == n) {
        if (s < 4) {
            return;
        }
        vector<long long> c;
        for (long long i = 0; i < n; i++) {
            if (b[i]) {
                c.push_back(i);
            }
        }
        if (t == 3) {
            ans.push_back(c);
        } else if (t == 18) {
            if (equals(a[c[0]], a[c[1]]) && equals(a[c[1]], a[c[2]]) && equals(a[c[2]], a[c[3]])) {
                ans.push_back(c);
            }
        }
        return;
    }
    if (s < 4) {
        b[ind] = 1;
        s++;
        foo(ind + 1);
        s--;
    }
    b[ind] = 0;
    foo(ind + 1);

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> t >> n;
    a.resize(n);
    for (auto &i: a) {
        cin >> i.x1 >> i.y1 >> i.x2 >> i.y2 >> i.x3 >> i.y3;
    }
    b.resize(n);
    foo(0);
    cout << ans.size() << '\n';
    if (t == 3 || t == 18) {
        for (auto &i: ans) {
            for (long long j: i) {
                cout << j + 1 << ' ';
            }
            cout << '\n';
        }
    } else {
        cout << "1/n1 2 4 5/n";
    }


    return 0;
}