#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, m;
    cin >> n >> m;
    vector<long long> a(n), b(m);
    for (long long &i: a) {
        cin >> i;
    }
    for (long long &i: b) {
        cin >> i;
    }
    long long mn = min(m, n);
    long long p = 5, mod = 1e9 + 7;
    vector<long long> h(n + 1);
    for (long long i = 1; i <= n; i++) {
        h[i] = h[i - 1] * p + a[i - 1];
    }
    vector<long long> rh(n + 1);
    for (long long i = 1; i <= n; i++) {
        rh[i] = rh[i - 1] * p + a[n - i];
    }

    vector<long long> sp(n + 1);
    sp[0] = 1;
    for (long long i = 1; i <= n; i++) {
        sp[i] = (sp[i - 1] * p) % mod;
    }

    long long l = 0, r;
    if (mn % 2 == 0) {
        r = mn + 2;
    } else {
        r = mn + 1;
    }
    while (r - l > 2) {
        long long k = (r + l) / 2;
        if (k % 2 == 1) {
            k--;
        }
        bool q = false;
        for (long long i = 0; i <= n - k; i++) {
            long long h1 = ((h[i + k] - h[i] * sp[k]) % mod + mod) % mod;
            long long h2 = ((rh[n - i] - rh[n - i - k] * sp[k]) % mod + mod) % mod;
            if (h1 == h2) {
                q = true;
                break;
            }
        }
        if (q) {
            l = k;
        } else {
            r = k;
        }
    }
    long long ans1 = l;

    l = 1;
    if (mn % 2 == 0) {
        r = mn + 1;
    } else {
        r = mn + 2;
    }
    while (r - l > 2) {
        long long k = (r + l) / 2;
        if (k % 2 == 0) {
            k++;
        }
        bool q = false;
        for (long long i = 0; i <= n - k; i++) {
            long long h1 = ((h[i + k] - h[i] * sp[k]) % mod + mod) % mod;
            long long h2 = ((rh[n - i] - rh[n - i - k] * sp[k]) % mod + mod) % mod;
            if (h1 == h2) {
                q = true;
                break;
            }
        }
        if (q) {
            l = k;
        } else {
            r = k;
        }
    }
    cout << max(ans1, l);

    return 0;
}
